include masm32rt.inc
include gdip.inc
include gdiplus.inc
includelib gdiplus.lib
.686p
.mmx
.xmm

WndProc proto hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

WND_DATA struct
	hdc			HDC 	?
	TimerID		DWORD	?
	dwTime		DWORD	?
WND_DATA ends

.code
main proc 
LOCAL wcex:WNDCLASSEX
LOCAL msg:MSG
LOCAL gsi:GdiplusStartupInput
LOCAL gtkn:PULONG

	mov gsi.GdiplusVersion,1
	mov gsi.DebugEventCallback,0
	mov gsi.SuppressBackgroundThread,0
	mov gsi.SuppressExternalCodecs,0
	invoke GdiplusStartup,ADDR gtkn,ADDR gsi,0

	mov wcex.hInstance,rv(GetModuleHandle,0)
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET WndProc
	mov wcex.cbClsExtra,NULL
	mov wcex.cbWndExtra,SIZEOF WND_DATA
	mov wcex.hbrBackground,0
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,chr$("Win32GDI+")
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx, ADDR wcex
	mov esi,rv(CreateWindowEx,NULL,wcex.lpszClassName,"win32,GDI+",WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,wcex.hInstance,NULL)
	invoke ShowWindow,esi,SW_SHOWNORMAL
	invoke UpdateWindow,esi

	.while 1
		invoke GetMessage,ADDR msg,NULL,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw
	
	invoke GdiplusShutdown,gtkn
	invoke ExitProcess,msg.wParam

main endp

WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL ps:PAINTSTRUCT
LOCAL graphics:PVOID	; object pointers
LOCAL pen:PVOID			;
LOCAL brush:PVOID		;
LOCAL x:REAL4

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_DESTROY
		invoke DeleteObject,rv(GetWindowLong,hWnd,WND_DATA.hdc)
		invoke DeleteAtom,rv(GetWindowLong,hWnd,WND_DATA.TimerID)
	.elseif uMsg == WM_CREATE

		mov esi,rv(GetDC,rv(GetDesktopWindow))
		mov ebx,rv(CreateCompatibleDC,esi)
		mov edi,rv(GetSystemMetrics,SM_CXSCREEN)
		invoke DeleteObject,rv(SelectObject,ebx,rv(CreateCompatibleBitmap,esi,edi,rv(GetSystemMetrics,SM_CYSCREEN)))
		invoke ReleaseDC,rv(GetDesktopWindow),esi
		invoke SetWindowLong,hWnd,WND_DATA.hdc,ebx
		
		invoke GdipCreateFromHDC,ebx,ADDR graphics
		invoke GdipGraphicsClear,graphics,ColorsWhite		
		invoke GdipDeleteGraphics,graphics		

		mov ebx,rv(AddAtom,"atom: drawing timer")
		invoke SetWindowLong,hWnd,WND_DATA.TimerID,ebx
		invoke SetTimer,hWnd,ebx,1000/24,0

		invoke SetWindowLong,hWnd,WND_DATA.dwTime,rv(GetTickCount)

	.elseif uMsg == WM_TIMER
		.if wParam == rv(GetWindowLong,hWnd,WND_DATA.TimerID)
			; get current time in ms
			mov esi,rv(GetTickCount)
			sub esi,rv(GetWindowLong,hWnd,WND_DATA.dwTime)
			
			; get our DC
			mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hdc)
			
			; create Graphics object from HDC
			invoke GdipCreateFromHDC,ebx,ADDR graphics
			
			; set world unit to millimeter (screen) - the default is pixels
			invoke GdipSetPageUnit,graphics,UnitMillimeter
			
			; set drawings quality
			invoke GdipSetSmoothingMode,graphics,SmoothingModeHighQuality
			
			; clear DC/Graphics
			invoke GdipGraphicsClear,graphics,ColorsWhite		
						
			; create pen. Take care for parameters type! -> msdn
			; UnitWorld -> the parameter <width> uses Graphics current Unit = millimeter.
			invoke GdipCreatePen1,ColorsBlack,FP4(1.0),UnitWorld,ADDR pen
			
			; create brush
			invoke GdipCreateSolidFill,ColorsAquamarine,ADDR brush
			
			; calculate x-pos from time: velocity = 3mm/s
			mov [esp-4],esi
			fild SDWORD ptr [esp-4]	; load time in ms
			fmul FP4(0.003)
			fstp x
			
			; do some drawing - for many function there are two forms: one for floating point values
			; and one for one for integer parameters. e.g.: GdipFillRectangle <-> GdipFillRectangleI
			invoke GdipFillRectangle,graphics,brush,x,FP4(10.0),FP4(20.0),FP4(20.0)
			invoke GdipDrawRectangle,graphics,pen,x,FP4(10.0),FP4(20.0),FP4(20.0)
			
			; draw a rectangle using alpha-value
			invoke GdipSetSolidFillColor,brush,(ColorsBeige XOR 0ff000000h) OR (128 SHL 24)
			invoke GdipFillRectangleI,graphics,brush,20,15,30,30
			invoke GdipSetPenColor,pen,(ColorsBlack XOR 0ff000000h) OR (128 SHL 24)
			invoke GdipDrawRectangleI,graphics,pen,20,15,30,30
						
			; delete the Graphics-object. The DC is still valid
			invoke GdipDeleteGraphics,graphics
			
			; delete brush and pen
			invoke GdipDeletePen,pen
			invoke GdipDeleteBrush,brush
			
			; force redraw
			invoke InvalidateRect,hWnd,0,0
		.endif
	.elseif uMsg == WM_PAINT
		invoke BeginPaint,hWnd,ADDR ps
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hdc)
		mov edx,ps.rcPaint.right
		sub edx,ps.rcPaint.left
		mov ecx,ps.rcPaint.bottom
		sub ecx,ps.rcPaint.top
		invoke BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,ebx,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
		invoke EndPaint,hWnd,ADDR ps	
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
WndProc endp
end main
